/* 
 * Copyright (C) 2000 Jeff Dike (jdike@karaya.com)
 * Licensed under the GPL
 */

#ifndef __UM_CURRENT_H
#define __UM_CURRENT_H

#ifndef __ASSEMBLY__

#include "asm/page.h"
#include "linux/thread_info.h"

#ifdef CONFIG_KRG_EPM
#define krg_current (current_thread_info()->task->effective_current)
#define current ({							\
	struct task_struct *__cur = current_thread_info()->task;	\
	__cur->effective_current ? __cur->effective_current : __cur;	\
})

#else

#define current (current_thread_info()->task)
#endif

/*Backward compatibility - it's used inside arch/um.*/
#define current_thread current_thread_info()

#endif /* __ASSEMBLY__ */

#endif

/*
 * Overrides for Emacs so that we follow Linus's tabbing style.
 * Emacs will notice this stuff at the end of the file and automatically
 * adjust the settings for this buffer only.  This must remain at the end
 * of the file.
 * ---------------------------------------------------------------------------
 * Local variables:
 * c-file-style: "linux"
 * End:
 */
