#ifndef __KKRG_CHILDREN_H__
#define __KKRG_CHILDREN_H__

#ifdef CONFIG_KRG_EPM

#include <linux/types.h>

struct children_ctnr_object;
struct task_struct;

extern
struct children_ctnr_object * (*kh_alloc_children)(struct task_struct *task);
extern void (*kh_share_children)(struct task_struct *task);
extern void (*kh_exit_children)(struct task_struct *task);
extern void (*kh_children_get)(struct children_ctnr_object *obj);
extern void (*kh_children_put)(struct children_ctnr_object *obj);
extern int (*kh_children_alive)(struct children_ctnr_object *obj);
extern int (*kh_new_child)(struct children_ctnr_object *obj,
			   pid_t parent_pid,
			   pid_t child_pid, pid_t pgid, pid_t sid,
			   int exit_signal);
extern void (*kh_set_child_pgid)(struct children_ctnr_object *obj,
				 pid_t pid, pid_t pgid);
extern void (*kh_set_child_exit_signal)(struct children_ctnr_object *obj,
					pid_t pid, int exit_signal);
extern void (*kh_remove_child)(struct children_ctnr_object *obj,
			       pid_t child_pid);
extern void (*kh_reparent_child)(struct children_ctnr_object *obj,
				 pid_t child_pid,
				 pid_t reaper_pid, int same_group);
extern void (*kh_forget_original_remote_parent)(struct task_struct *parent,
						struct task_struct *reaper);
extern void (*kh_reparent_to_local_child_reaper)(struct task_struct *task);
extern int (*kh_may_be_eligible_child)(struct children_ctnr_object *obj,
				       pid_t pid,
				       int options);
extern pid_t (*kh_get_real_parent_tgid)(struct task_struct *task);
extern int (*kh_get_parent)(struct children_ctnr_object *obj, pid_t pid,
			    pid_t *parent_pid, pid_t *real_parent_pid);
extern struct children_ctnr_object * (*kh_children_writelock)(pid_t tgid);
extern
struct children_ctnr_object * (*kh_children_writelock_nested)(pid_t tgid);
extern struct children_ctnr_object * (*kh_children_readlock)(pid_t tgid);
extern struct children_ctnr_object * (*kh_parent_children_writelock)(
	struct task_struct *task,
	pid_t *parent_tgid);
extern struct children_ctnr_object * (*kh_parent_children_readlock)(
	struct task_struct *task,
	pid_t *parent_tgid);
extern void (*kh_children_unlock)(pid_t tgid);
extern void (*kh_add_parent)(struct task_struct *task,
			     struct task_struct *parent);
extern void (*kh_remove_parent)(struct task_struct *task);

#endif /* CONFIG_KRG_EPM */

#endif /* __KKRG_CHILDREN_H__ */
