#ifndef __KKRG_KERNEL_HEADERS__
#define __KKRG_KERNEL_HEADERS__

#include <linux/autoconf.h>
#include <asm/atomic.h>
#include <linux/futex.h>
#include <linux/rwsem.h>
#include <kerrighed/types.h>
#include <kerrighed/krginit.h>

struct inode;
struct vfsmount;
struct sockaddr_un;

/* Used in arch/<*>/mm/fault.c and epm/ghost_process_api.c */
void show_registers(struct pt_regs *regs);

/* kernel/kerrighed.c */

#ifdef CONFIG_FD_V1
/* FORK_DELAY */
extern int jeton;
extern int var_chan_admin;
extern void msleep (unsigned int msecs);
#endif //CONFIG_FD_V1
#ifdef CONFIG_KRG_FD
extern int vload;
extern int nb_process_delayed;
extern int threshold;
extern int threshold_scheduler;
extern int wait_time;
//see fd_status
typedef enum{
  PFD_OK,
    PFD_BLOCKED
    } pfd_status;
struct l_p_delay{
  struct task_struct *p;
  unsigned long clone_flags;
  pfd_status fd_status; //process in the pfd_list but authorized (or NOT) to be woke up
  struct list_head lh;
};
extern struct l_p_delay head_list_fd;
extern int init_fd;
extern int (*kh_fd_send_msg)(int code, int type);
#endif //CONFIG_KRG_FD


/* Stream */
ssize_t bad_pipe_r(struct file *filp, char *buf,
		size_t count, loff_t *ppos);
ssize_t bad_pipe_w(struct file *filp, const char *buf,
		size_t count, loff_t *ppos);
int pipe_ioctl(struct inode *pino, struct file *filp,
		unsigned int cmd, unsigned long arg);
int unix_mkname(struct sockaddr_un * sunaddr, int len, unsigned *hashp);

int local_stream_flush(struct file * filp);

extern void (*setup_krg_read_pipe)(struct file *);
extern void (*setup_krg_write_pipe)(struct file *);
extern struct inode * (*get_krg_pipe_inode)(struct vfsmount *);

extern struct vfsmount *pipe_mnt;


#ifdef CONFIG_KRG_SYNC
extern int (*kh_futex_queue_me)(struct futex_q *q);
extern int (*kh_futex_wake)(union futex_key *key, int nr_wake, int nr_woken);
#endif // CONFIG_KRG_SYNC

#ifdef CONFIG_KRG_STREAM
extern struct proto_ops unix_stream_ops;
extern struct proto_ops unix_dgram_ops;
extern struct proto_ops unix_seqpacket_ops;

extern struct proto_ops *kernet_socket_ops;
extern struct proto *kernet_socket_proto;

extern struct proto_ops *kernet_unix_stream_ops;
extern struct proto_ops *kernet_unix_datagram_ops;

extern struct proto_ops *kernet_inet_stream_ops;
extern struct proto_ops *kernet_inet_datagram_ops;
#endif

#endif /* __KKRG_KERNEL_HEADERS__ */
