#ifndef __KKRG_MM__
#define __KKRG_MM__

#include <linux/err.h>
#include <linux/fs.h>

#ifdef CONFIG_USERMODE
#ifdef PTE_MASK
// At this time (2.6.11) PTE_MASK is not defined in UM, so as soon as this
// will be defined, we will remove this part
#warning PTE_MASK already defined
#else
#define PTE_MASK PAGE_MASK
#endif
#endif



/** Kerrighed Extra vm_flags **/

#define VM_CONTAINER  0x08000000



/** Exported Functions **/

int alloc_ldt(mm_context_t *pc, int mincount, int reload) ;
void exit_mm(struct task_struct * tsk);



/** Exported Variables **/

extern struct kmem_cache *mm_cachep;
extern struct vm_operations_struct shmem_vm_ops;
extern struct vm_operations_struct generic_file_vm_ops ;
extern struct vm_operations_struct shmem_vm_ops  ;

static inline void dump_vma(struct task_struct *tsk)
{
  struct vm_area_struct *vma;

  vma = tsk->mm->mmap;

  while(vma)
    {
      printk ("[0x%08lx:0x%08lx] - flags 0x%08lx - offset 0x%08lx - "
              "file %p\n", vma->vm_start, vma->vm_end, vma->vm_flags,
              vma->vm_pgoff, vma->vm_file);

      vma = vma->vm_next;
    }
}



/** Kerrighed Kernel Hooks **/

extern int (*kh_copy_mm)(unsigned long clone_flags, struct mm_struct *mm,
                        struct mm_struct *oldmm);

extern void (*kh_mmdrop) (struct mm_struct *mm);


#define TestClearPageLRU(page)  test_and_clear_bit(PG_lru, &(page)->flags)

#endif // __KKRG_MM__
