#ifndef __KKRG_PROCFS__
#define __KKRG_PROCFS__

#ifdef CONFIG_KRG_PROCFS

#ifdef CONFIG_KRG_PROC

#include <linux/proc_fs.h>
#include <linux/fs.h>
#include <linux/types.h>

#define get_krg_proc_task(inode) (&PROC_I(inode)->distant_proc)

#endif /* CONFIG_KRG_PROC */

struct seq_file;

int show_cpuinfo(struct seq_file *m, void *v);

#ifdef CONFIG_KRG_PROC

extern struct inode_operations proc_def_inode_operations;

struct task_struct;

int proc_setattr(struct dentry *dentry, struct iattr *attr);
int do_proc_readlink(struct dentry *dentry, struct vfsmount *mnt,
		     char __user *buffer, int buflen);

int proc_pid_fill_cache(struct file *filp, void *dirent, filldir_t filldir,
			struct task_struct *task, int tgid);

int proc_tgid_stat(struct task_struct *, char *);
int proc_pid_status(struct task_struct *, char *);
int proc_pid_statm(struct task_struct *, char *);
int proc_pid_environ(struct task_struct *task, char *buffer);
int proc_pid_cmdline(struct task_struct *task, char *buffer);

extern int (*kh_task_cpu)(struct task_struct *task);
extern struct dentry * (*kh_proc_pid_lookup)(struct inode *dir,
					     struct dentry *dentry, pid_t pid);
extern int (*kh_proc_pid_readdir)(struct file *filp,
				  void *dirent, filldir_t filldir,
				  loff_t offset);

#endif /* CONFIG_KRG_PROC */

#endif /* CONFIG_KRG_PROCFS */

#endif
