#ifndef __KKRG_SCHED_H__
#define __KKRG_SCHED_H__

#ifdef CONFIG_KRG_EPM

#include <linux/types.h>
#include <kerrighed/sys/types.h>

/* WARNING: these flags must not overwrite the flags defined in linux/sched.h
 * The place is becoming sparse ... */

#define PF_EXIT_NOTIFYING  0x00000008  /* I am exiting and notifying my remote
					* parent */
#define PF_DISTANT_FORKING 0x04000000  /* I am doing a distant fork */
#define PF_MIGRATING       0x08000000  /* I am migrating */
#define PF_CHECKPOINTING   0x40000000  /* I am doing a checkpoint */
#define PF_AWAY		   0x80000000  /* I don't want to be considered as local
					* by my relatives */

#define PF_KERRIGHED_ACTION (PF_DISTANT_FORKING | PF_MIGRATING	\
			     | PF_CHECKPOINTING)

struct task_struct;
struct pt_regs;

extern struct task_struct *baby_sitter;

/* remote clone */
extern int (*kh_do_fork)(unsigned long clone_flags,
			 unsigned long stack_start,
			 struct pt_regs *regs,
			 unsigned long stack_size,
			 int *parent_tidptr,
			 int *child_tidptr);

/* pgrp */
extern int (*kh_will_become_orphaned_pgrp)(pid_t pgrp, pid_t ignored_kid);

/* exit */
extern int (*kh_exit_notify)(struct task_struct *task,
			     kerrighed_node_t parent_node,
			     int sig_num,
			     pid_t groupid, pid_t sessionid);
extern void (*kh_delay_release_task)(struct task_struct *task);

/* migration */
fastcall NORET_TYPE void do_exit_wo_notify(long error_code)
	ATTRIB_NORET;

#endif /* CONFIG_KRG_EPM */

#ifdef CONFIG_KRG_SCHED
extern void (*kh_calc_load)(unsigned long ticks);
extern void (*kh_process_on)(struct task_struct *tsk);
extern void (*kh_process_off)(struct task_struct *tsk);
#endif /* CONFIG_KRG_SCHED */

#endif /* __KKRG_SCHED_H__ */
