#ifndef __KKRG_SIGNAL_H__
#define __KKRG_SIGNAL_H__

#ifdef CONFIG_KRG_PROC

#include <linux/types.h>

/* signal_struct sharing */

struct kmem_cache;

/* exported from kernel/fork.c */
extern struct kmem_cache *signal_cachep;

struct signal_struct;
struct task_struct;

extern
struct signal_struct * (*kh_malloc_signal_struct)(struct task_struct *task,
						  int need_update);
extern void (*kh_share_signal)(struct task_struct *task);
extern pid_t (*kh_exit_signal)(struct task_struct *task);
extern struct signal_struct * (*kh_signal_struct_readlock)(pid_t tgid);
extern struct signal_struct * (*kh_signal_struct_writelock)(pid_t tgid);
extern void (*kh_signal_struct_unlock)(pid_t tgid);

#endif /* CONFIG_KRG_PROC */

#ifdef CONFIG_KRG_EPM

/* sighand_struct sharing */

struct sighand_struct;

extern
struct sighand_struct * (*kh_malloc_sighand_struct)(struct task_struct *task,
						    int need_update);
extern void (*kh_share_sighand)(struct task_struct *task);
extern unsigned long (*kh_exit_sighand)(unsigned long id);
extern struct sighand_struct * (*kh_sighand_struct_readlock)(unsigned long id);
extern struct sighand_struct * (*kh_sighand_struct_writelock)(unsigned long id);
extern void (*kh_sighand_struct_unlock)(unsigned long id);

extern int next_signal(struct sigpending *pending, sigset_t *mask);

#endif /* CONFIG_KRG_EPM */

#endif /* __KKRG_SIGNAL_H__ */
