#ifndef __KKRG_TASK_H__
#define __KKRG_TASK_H__

#ifdef CONFIG_KRG_PROC

#include <linux/types.h>
#include <asm/cputime.h>
#include <linux/rwsem.h>
#include <linux/kref.h>
#include <kerrighed/sys/types.h>

/* task container */

struct task_struct;
struct thread_info;
#ifdef CONFIG_KRG_EPM
struct pid_ctnr_object;
#endif

struct task_ctnr_object {
	volatile long state;
	unsigned long flags;
	unsigned long ptrace;
	long exit_state;
	int exit_code, exit_signal;

#if 0
	struct {
		int state;
		pid_t waited_by;
		int exit_value;
	} krg_thread;
#endif

	kerrighed_node_t node;
	u32 self_exec_id;
	int thread_group_empty;

	unsigned long sighand_struct_id;

	pid_t pid;
	pid_t parent;
	pid_t real_parent;
	pid_t real_parent_tgid;
	pid_t group_leader;

	uid_t uid;
	uid_t euid;
	gid_t egid;

	cputime_t utime, stime;

	unsigned dumpable;

	/* The remaining fields are not shared */
#ifdef CONFIG_KRG_EPM
	struct pid_ctnr_object *pid_obj;
#endif
	struct task_struct *task;

	struct rw_semaphore sem;
	int write_locked;

	int alive;
	struct kref kref;
};

/* task_struct allocation outside kernel/fork.c */
/* Copy from: Linux kernel 2.6.20, kernel/fork.c, lines 90..94 */
#include <asm/thread_info.h>
#ifndef __HAVE_ARCH_TASK_STRUCT_ALLOCATOR
#include <linux/slab.h>
# define alloc_task_struct()    kmem_cache_alloc(task_struct_cachep, GFP_KERNEL)
# define free_task_struct(tsk)  kmem_cache_free(task_struct_cachep, (tsk))
extern struct kmem_cache *task_struct_cachep;
#endif

extern void (*kh_task_get)(struct task_ctnr_object *obj);
extern void (*kh_task_put)(struct task_ctnr_object *obj);
extern int (*kh_task_alive)(struct task_ctnr_object *obj);
extern struct task_ctnr_object * (*kh_task_readlock)(pid_t pid);
extern struct task_ctnr_object * (*kh_task_writelock)(pid_t pid);
extern struct task_ctnr_object * (*kh_task_writelock_nested)(pid_t pid);
extern void (*kh_task_unlock)(pid_t pid);
extern struct task_struct * (*kh_malloc_task_struct)(pid_t pid);
extern void (*kh_free_task_struct)(struct task_struct *task);

/* exit */
extern void (*kh_release_task)(struct task_struct *task);

/* kerrighed_task (to be removed) */
extern void (*kh_copy_process)(struct task_struct *tsk);

#endif /* CONFIG_KRG_PROC */

#endif /* __KKRG_TASK_H__ */
