/*
 *  Copyright (C) 2006-2007, Renaud Lottiaux, Kerlabs.
 */

#include <linux/module.h>
#include <linux/msg.h>
#include <../ipc/util.h>
#include <linux/ipc.h>
#include <linux/shm.h>
#include <linux/mm.h>
#include <linux/lockdep.h>



/** Kerrighed Kernel Hooks **/

/* Cluster wide SHM management */

struct shmid_kernel * (*kh_shm_lock)(struct ipc_namespace *ns, int id) = NULL;
void (*kh_shm_unlock)(struct shmid_kernel *shp) = NULL;

int (*kh_shm_newseg) (struct ipc_namespace *ns, 
		      struct shmid_kernel * shp) = NULL ;
void (*kh_shm_destroy)(struct ipc_namespace *ns,
		       struct shmid_kernel *shp) = NULL ;
void (*kh_shm_rmkey)(struct ipc_namespace *ns,
		     struct shmid_kernel *shp) = NULL ;
int (*kh_shm_get_max_id)(struct ipc_namespace *ns, struct ipc_ids* ids) = NULL;
int (*kh_get_ipc_id)(struct ipc_ids *ids, int size) = NULL;
int (*kh_ipc_findkey)(struct ipc_ids *ids, key_t key) = NULL;



/** Kerrighed Definitions **/

struct vm_operations_struct krg_shmem_vmops;

struct lock_class_key ipcid_lock_key;


/** Kerrighed Exported Symbols **/

EXPORT_SYMBOL(ipc_rcu_alloc);
EXPORT_SYMBOL(ipc_addid);
EXPORT_SYMBOL(ipc_rcu_putref);
EXPORT_SYMBOL(shm_inc);
EXPORT_SYMBOL(shm_close);
EXPORT_SYMBOL(krg_shmem_vmops);
EXPORT_SYMBOL(ipcid_lock_key);

EXPORT_SYMBOL(grow_ary);
EXPORT_SYMBOL(_shm_destroy);
EXPORT_SYMBOL(shmem_file_setup);
EXPORT_SYMBOL(shm_file_operations);
EXPORT_SYMBOL(kh_shm_lock);
EXPORT_SYMBOL(kh_shm_unlock);
EXPORT_SYMBOL(kh_shm_newseg);
EXPORT_SYMBOL(kh_shm_get_max_id);
EXPORT_SYMBOL(kh_shm_destroy);
EXPORT_SYMBOL(kh_shm_rmkey);
EXPORT_SYMBOL(kh_get_ipc_id);
EXPORT_SYMBOL(kh_ipc_findkey);
EXPORT_SYMBOL(init_ipc_ns);
EXPORT_SYMBOL(ipc_lock);
EXPORT_SYMBOL(ipc_unlock);
