/*
 *  Copyright (C) 2006-2007, Pascal Gallard, Kerlabs.
 */

#include <linux/module.h>
#include <linux/sched.h>
#include <linux/proc_fs.h>
#include <linux/file.h>
#include <linux/mm.h>
#include <linux/syscalls.h>
#include <linux/rmap.h>
#include <linux/acct.h>
#include <linux/pagemap.h>
#include <linux/fs.h>
#include <linux/rwsem.h>
#include <asm/pgalloc.h>
#include <asm/pgtable.h>
#include <asm/tlbflush.h> // Needed for UserMode
#include <asm/unistd.h>
#ifndef CONFIG_USERMODE
#include <asm/sigcontext.h>
#else
#include <sigcontext.h>
#endif

#include <linux/msg.h>
#include <linux/reboot.h>
#include <../fs/proc/internal.h>

#include <kerrighed/kernel_headers.h>

/*
 * Additionnal kernel symbol
 */

#ifdef CONFIG_USERMODE
void show_registers(struct pt_regs *regs)
{
  printk("show_registers is not supported using UML\n");
}
#endif

EXPORT_SYMBOL(show_registers);
EXPORT_SYMBOL(machine_restart);

#ifdef CONFIG_KRG_STREAM_PIPE
EXPORT_SYMBOL(bad_pipe_r);
EXPORT_SYMBOL(bad_pipe_w);
EXPORT_SYMBOL(pipe_ioctl);
EXPORT_SYMBOL(pipe_mnt);
#endif /* CONFIG_KRG_STREAM_PIPE */
#if defined(CONFIG_KRG_STREAM_INET) || defined(CONFIG_KRG_STREAM_UNIX)
EXPORT_SYMBOL(sock_mnt);
EXPORT_SYMBOL(sockfs_dentry_operations);
EXPORT_SYMBOL(socket_file_ops);
EXPORT_SYMBOL(sock_change);
EXPORT_SYMBOL(sock_alloc);
#endif

#ifdef CONFIG_USERMODE
EXPORT_SYMBOL(um_execve);
EXPORT_SYMBOL(sc_to_sc);
#endif // CONFIG_USERMODE

#ifdef CONFIG_KRG_HOTPLUG
EXPORT_SYMBOL(emergency_sync);
EXPORT_SYMBOL(emergency_remount);
#endif

#ifdef CONFIG_KRG_CTNR
EXPORT_SYMBOL(radix_tree_preload);
#endif

#ifdef CONFIG_KRG_COMMUNICATION_FRAMEWORK
EXPORT_SYMBOL(tasklist_lock);
#endif
