/*
 *  Kerrighed/kernel/kerrighed/procfs.c
 *
 *  Copyright (C) 1999-2006 INRIA, Universite de Rennes 1, EDF
 *  Copyright (C) 2007 Louis Rilling - Kerlabs
 */

#include <linux/module.h>

#ifdef CONFIG_KRG_PROC
/* /proc/<pid>/ */

/* Kerrighed hooks */
#include <linux/fs.h>
#include <linux/types.h>

struct task_struct;
struct inode;
struct dentry;

int (*kh_task_cpu)(struct task_struct *task);
struct dentry * (*kh_proc_pid_lookup)(struct inode *dir,
				      struct dentry *dentry, pid_t pid);
int (*kh_proc_pid_readdir)(struct file *filp,
			   void *dirent, filldir_t filldir,
			   loff_t offset);
EXPORT_SYMBOL(kh_task_cpu);
EXPORT_SYMBOL(kh_proc_pid_lookup);
EXPORT_SYMBOL(kh_proc_pid_readdir);
#endif /* CONFIG_KRG_PROC */

#ifdef CONFIG_KRG_PROC
int proc_pid_environ(struct task_struct *task, char *buffer);
int proc_pid_cmdline(struct task_struct *task, char *buffer);
#endif

struct seq_file;

int show_cpuinfo(struct seq_file *m, void *v);

#include <linux/pid.h>
#include "../fs/proc/internal.h"
#include <kerrighed/procfs.h>
#include <linux/sched.h>
#include <linux/highmem.h>
#include <linux/swap.h>
#include <linux/mmzone.h>
#include <linux/kernel_stat.h>
#include <linux/time.h>
#include <linux/mman.h>
#include <linux/hugetlb.h>

/* vanilla Linux symbols */
#ifdef CONFIG_KRG_PROC
/* EXPORT_SYMBOL(last_pid); */
/* EXPORT_SYMBOL(get_page_state); */
/* EXPORT_SYMBOL(do_posix_clock_monotonic_gettime); */
/* EXPORT_SYMBOL(boot_cpu_data); */
EXPORT_SYMBOL(find_ge_pid);
EXPORT_SYMBOL(is_subdir);
EXPORT_SYMBOL(proc_def_inode_operations);
EXPORT_SYMBOL(proc_setattr);
EXPORT_SYMBOL(do_proc_readlink);
EXPORT_SYMBOL(proc_pid_fill_cache);
EXPORT_SYMBOL(proc_tgid_stat);
EXPORT_SYMBOL(proc_pid_statm);
EXPORT_SYMBOL(proc_pid_status);
EXPORT_SYMBOL(proc_pid_environ);
EXPORT_SYMBOL(proc_pid_cmdline);
#endif

EXPORT_SYMBOL(show_cpuinfo);
EXPORT_SYMBOL(get_vmalloc_info);

EXPORT_SYMBOL(total_forks);
EXPORT_SYMBOL(nr_iowait);
EXPORT_SYMBOL(nr_threads);
#ifdef CONFIG_HIGHMEM
EXPORT_SYMBOL(totalhigh_pages);
#endif
EXPORT_SYMBOL(si_swapinfo);
EXPORT_SYMBOL(get_zone_counts);
EXPORT_SYMBOL(nr_running);
EXPORT_SYMBOL(nr_context_switches);
EXPORT_SYMBOL(wall_to_monotonic);
EXPORT_SYMBOL(vm_committed_space);
EXPORT_SYMBOL(swapper_space);
EXPORT_SYMBOL(total_swap_pages);
EXPORT_SYMBOL(sysctl_overcommit_ratio);
EXPORT_SYMBOL(hugetlb_total_pages);

